import com.aspose.tasks.*;

import java.io.FileInputStream;
import java.io.FileNotFoundException;

class FindByName {
    /// <summary>
    /// main method
    /// </summary>
    public static void main(String[] args) {
        try {
            if (args.length != 2) {
                System.out.println("Usage: Aspose.Tasks.FindByName <input file name> <taskName>");
            } else {
                find(args[0], args[1]);
            }
        } catch (Exception ex) {
            System.out.println(ex.getStackTrace());
        }
    }

    /// <summary>
    /// Finds taks by name and prinst task name, uid, id, date start and date end
    /// </summary>
    /// <param name="fileName"></param>
    /// <param name="taskName"></param>
    private static void find(String fileName, String taskName) throws FileNotFoundException {
        // reads project from file
        ProjectReader reader = new ProjectReader();
        Project project = reader.read(new FileInputStream(fileName));

        // Searching task
        Task task = TaskUtils.find(project.getRootTask(), new NameCondition(taskName));

        // Prints task parameters
        if (task != null) {
            System.out.println("Name   : " + task.getName());
            System.out.println("UID    : " + task.getUid());
            System.out.println("ID     : " + task.getId());
            System.out.println("Start  : " + task.getStart());
            System.out.println("Finish : " + task.getFinish());
        }
    }
}

/// <summary>
/// Define find condition. Method check() of this class returns true if task name starts with the pattern otherwise returns false;
/// </summary>
class NameCondition implements ICondition {
    private String pattern;

    public NameCondition(String pattern) {
        this.pattern = pattern;
    }

    public boolean check(Object el) {
        Task task = (Task) el;
        if (task.getName() != null) {
            return task.getName().startsWith(pattern);
        }
        return false;
    }
}