import com.aspose.tasks.*;
import sun.awt.HorizBagLayout;

import javax.swing.*;
import javax.swing.border.LineBorder;
import javax.swing.filechooser.FileNameExtensionFilter;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;

public class ImageRenderingFrame extends JFrame {

    /// <summary>
    /// Project to render.
    /// </summary>
    private Project project;

    /// <summary>
    /// List of all project's tasks. Just to cache them.
    /// </summary>
    private List<Task> tasks = new ArrayList<Task>();


    private JLabel label1;
    private JTextField tbFile;
    private JButton btSelect;
    private JLabel label2;
    private JLabel label3;
    private JLabel label4;
    private JLabel label5;
    private JSpinner nuWidth;
    private JSpinner nuHeight;
    private JSpinner nuZoom;
    private JSpinner nuPage;
    private JButton btSave;
    private JCheckBox cbLegend;
    private JButton button1;
    private JPanel groupBox1;
    private JList clExpanded;
    private JCheckBox cbExpandAll;
    private JScrollPane scrollPane;

    public ImageRenderingFrame(String title){
        super(title);
        createGUI();
    }

    private void createGUI(){
        this.label1 = new JLabel();
        this.tbFile = new JTextField();
        this.btSelect = new JButton();
        this.label2 = new JLabel();
        this.label3 = new JLabel();
        this.label4 = new JLabel();
        this.label5 = new JLabel();
        this.nuWidth = new JSpinner(new SpinnerNumberModel(800,1,1000,1));
        this.nuHeight = new JSpinner(new SpinnerNumberModel(800,1,1000,1));
        this.nuZoom = new JSpinner(new SpinnerNumberModel(100,1,1000,1));
        this.nuPage = new JSpinner(new SpinnerNumberModel(0,0,100,1));
        this.btSave = new JButton();
        this.cbLegend = new JCheckBox();
        this.button1 = new JButton();
        this.groupBox1 = new JPanel();
        this.clExpanded = new JList();
        this.cbExpandAll = new JCheckBox();
        scrollPane = new JScrollPane();

        this.getContentPane().setLayout(null);
        //
        // label1
        //
        this.label1.setLocation(20, 37);
        this.label1.setName("label1");
        this.label1.setSize(70, 13);
        this.label1.setText("Project file:");
        this.setLayout(null);
        this.getContentPane().add(label1);
        //
        // tbFile
        //
        this.tbFile.setLocation(100, 35);
        this.tbFile.setName("tbFile");
        this.tbFile.setSize(303, 20);
        this.getContentPane().add(tbFile);
        //
        // btSelect
        //
        this.btSelect.setLocation(410, 33);
        this.btSelect.setName("btSelect");
        this.btSelect.setSize(79, 23);
        this.btSelect.setText("Select");
        btSelect.addActionListener(new PushingListener());
        this.getContentPane().add(btSelect);
        //
        // label2
        //
        this.label2.setLocation(20, 80);
        this.label2.setName("label2");
        this.label2.setSize(90, 13);
        this.label2.setText("Image Width:");
        this.getContentPane().add(label2);
        //
        // label3
        //
        this.label3.setLocation(20, 114);
        this.label3.setName("label3");
        this.label3.setSize(90, 13);
        this.label3.setText("Image Height:");
        this.getContentPane().add(label3);
        //
        // label4
        //
        this.label4.setLocation(20, 149);
        this.label4.setName("label4");
        this.label4.setSize(90, 13);
        this.label4.setText("Zoom:");
        this.getContentPane().add(label4);
        //
        // label5
        //
        this.label5.setLocation(20, 180);
        this.label5.setName("label5");
        this.label5.setSize(90, 13);
        this.label5.setText("Page number:");
        this.getContentPane().add(label5);
        //
        // nuWidth
        //
        this.nuWidth.setLocation(125, 78);
        this.nuWidth.setName("nuWidth");
        this.nuWidth.setSize(120, 20);
        this.getContentPane().add(nuWidth);
        //
        // nuHeight
        //
        this.nuHeight.setLocation(125, 112);
        this.nuHeight.setName("nuHeight");
        this.nuHeight.setSize(120, 20);
        this.getContentPane().add(nuHeight);
        //
        // nuZoom
        //
        this.nuZoom.setLocation(125, 147);
        this.nuZoom.setName("nuZoom");
        this.nuZoom.setSize(120, 20);
        this.getContentPane().add(nuZoom);
        //
        // nuPage
        //
        this.nuPage.setLocation(125, 178);
        this.nuPage.setName("nuPage");
        this.nuPage.setSize(120, 20);
        this.getContentPane().add(nuPage);
        //
        // btSave
        //
        this.btSave.setLocation(167, 254);
        this.btSave.setName("btSave");
        this.btSave.setSize(75, 23);
        this.btSave.setText("Save");
        btSave.addActionListener(new SaveListener());
        this.getContentPane().add(btSave);
        //
        // cbLegend
        //
        this.cbLegend.setLocation(125, 214);
        this.cbLegend.setName("cbLegend");
        this.cbLegend.setSize(150, 17);
        this.cbLegend.setText("Legend on each page");
        this.getContentPane().add(cbLegend);
        //
        // groupBox1
        //
        this.groupBox1.setLocation(277, 80);
        this.groupBox1.setName("groupBox1");
        this.groupBox1.setSize(220, 150);
        this.groupBox1.setBorder(new LineBorder(Color.GRAY, 1));
        this.groupBox1.setLayout(null);
        //
        // clExpanded
        //
        scrollPane.setLocation(5, 25);
        scrollPane.setSize(210, 120);
        this.clExpanded.setLocation(0, 0);
        this.clExpanded.setName("clExpanded");
        this.clExpanded.setSize(220, 125);
        scrollPane.setViewportView(clExpanded);
        //
        // cbExpandAll
        //
        this.cbExpandAll.setSelected(true);
        this.cbExpandAll.setLocation(7, 5);
        this.cbExpandAll.setName("cbExpandAll");
        this.cbExpandAll.setSize(140, 20);
        this.cbExpandAll.setText("Expand all tasks");
        this.groupBox1.add(this.cbExpandAll);
        this.groupBox1.add(this.scrollPane);
        this.getContentPane().add(groupBox1);
        //
        // ImageRenderingForm
        //
        this.setName("ImageRenderingFrame");
    }

    /**
     *   Select project file to render.
     */
    class PushingListener implements ActionListener {
        public void actionPerformed(ActionEvent e){
            JFileChooser fileopen = new JFileChooser();
            //fileopen.setCurrentDirectory(new File("C:\\Temp\\Rendering\\Software Development.mpp"));
            fileopen.setFileFilter(new FileNameExtensionFilter("project files (*.mpp)", "mpp"));
            int ret = fileopen.showDialog(null, "Open file");
            if (ret == JFileChooser.APPROVE_OPTION) {
                File file = fileopen.getSelectedFile();
                tbFile.setText(file.getAbsolutePath());
                ProjectReader reader = new ProjectReader();
                try {
                    project = reader.read(new FileInputStream(file.getAbsolutePath()));
                } catch (FileNotFoundException e1) {
                }
                loadCheckList(project);
            }
        }
    }

    /**
     * Render project as an image.
     */
    class SaveListener implements ActionListener {
        public void actionPerformed(ActionEvent e){
            if (tbFile.getText() != "" && new File(tbFile.getText()).exists())
            {
                try
                {
                    ArrayList uids = new ArrayList();
                    for (int index : clExpanded.getSelectedIndices())
                    uids.add(((Task)tasks.get(index)).getUid());
                    IRenderResult res = project.export(RenderFormat.Image, PresentationFormat.GanttChart, "image.jpeg",
                            new BaseImageRenderParam(null, new Point(0,0), new Dimension((Integer) nuWidth.getValue(), (Integer) nuHeight.getValue()),
                                    (Integer) nuZoom.getValue(), (Integer) nuPage.getValue(), cbLegend.isSelected()), cbExpandAll.isSelected(), (ArrayList)uids);
                    if (res.getResult() != RenderResult.OK)
                        JOptionPane.showMessageDialog(ImageRenderingFrame.this, "Error:" + res.getMessage());
                    else
                        JOptionPane.showMessageDialog(ImageRenderingFrame.this, "Image was saved into 'image.jpeg' file successfully.");
                }
                catch (Exception ex)
                {
                    JOptionPane.showMessageDialog(ImageRenderingFrame.this, "Exception:" + ex.getMessage());
                }
            }
        }
    }

    /**
     * Load tasks to selection check list. There are parent tasks to be expanded.
     * @param project
     */
    private void loadCheckList(Project project)
    {
        //this.clExpanded.getItems.Clear();
        tasks = getAllProjectTasks(project);
        ArrayList<String> list = new ArrayList<String>();
        for (Task task : tasks)
        {
            list.add(task.getId()  + ". " + task.getName());
        }
        clExpanded.setListData(list.toArray());
        clExpanded.revalidate();
        scrollPane.revalidate();
    }

    /**
     * Auxiliary method to load all project's tasks.
     * @param project
     * @return
     */
    private ArrayList getAllProjectTasks(Project project)
    {
        ArrayList res = new ArrayList();
        if(project.getRootTask() != null)
            for (Task task : project.getRootTask().getChildren())
        {
            res.add(task);

            res.addAll(getAllChildren(task));
        }
        return res;
    }

    /// <summary>
    /// Recursive method to load children.
    /// </summary>
    /// <param name="task">Task to load.</param>
    /// <returns>Array list of task's children.</returns>
    private ArrayList getAllChildren(Task task)
    {
        ArrayList res = new ArrayList();
        if(task.getChildren() != null)
            for (Task child : task.getChildren())
        {
            res.add(child);
            res.addAll(getAllChildren(child));
        }
        return res;
    }
}
